## React and D3 Charting

Modular ReactJS charts made using [d3](https://d3js.org/) chart utilities.

[![npm version](https://badge.fury.io/js/react-d3-responsive.svg)](https://badge.fury.io/js/react-d3-responsive)

## Usage

The latest version of react-d3-responsive requires **React 0.14 or later** and **D3 3.5.4 or later**.

**No support d3@v4.0 currently**

### NPM
Via `npm`:

```
npm install react-d3-responsive
```

Import into your ReactJS project:

```js
// es6
import {AreaGraph, BarGraph, LineGraph, PieChart, ScatterPlot} from 'react-d3-responsive';
```

### Available Charts

* AreaGraph
* BarGraph
* LineGraph
* PieChart
* ScatterPlot

[For usage.](https://cox-auto-kc.github.io/react-d3-responsive/)

### Support
Issues: [react-d3-responsive](https://github.com/cox-auto-kc/react-d3-responsive/issues) on Github

### Background
Inspired by [this blog post](http://www.adeveloperdiary.com/react-js/create-reusable-charts-react-d3-part1/) by Abhisek Jana of [A Developer Diary](http://www.adeveloperdiary.com/)

Also referencing [rd3](https://github.com/yang-wei/rd3) by Yang Wei for structure

### License
MIT

Copyright &copy; 2016 Drew Thorson

