'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _d = require('d3');

var _d2 = _interopRequireDefault(_d);

var _axis = require('../utilities/axis');

var _axis2 = _interopRequireDefault(_axis);

var _axisLabel = require('../utilities/axisLabel');

var _axisLabel2 = _interopRequireDefault(_axisLabel);

var _grid = require('../utilities/grid');

var _grid2 = _interopRequireDefault(_grid);

var _dataPoints = require('../utilities/dataPoints');

var _dataPoints2 = _interopRequireDefault(_dataPoints);

var _tooltip = require('../utilities/tooltip');

var _tooltip2 = _interopRequireDefault(_tooltip);

var _trendLine = require('../utilities/trendLine');

var _trendLine2 = _interopRequireDefault(_trendLine);

var _legend = require('../utilities/legend');

var _legend2 = _interopRequireDefault(_legend);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ScatterPlot = function (_React$Component) {
  _inherits(ScatterPlot, _React$Component);

  function ScatterPlot(props) {
    _classCallCheck(this, ScatterPlot);

    var _this = _possibleConstructorReturn(this, (ScatterPlot.__proto__ || Object.getPrototypeOf(ScatterPlot)).call(this, props));

    _this.updateSize = function () {
      var node = _reactDom2.default.findDOMNode(_this);
      var parentWidth = node.offsetWidth;
      parentWidth < _this.props.width ? _this.setState({ width: parentWidth }) : _this.setState({ width: _this.props.width });
    };

    _this.showToolTip = function (e) {
      _this.setState({
        tooltip: {
          display: true,
          data: {
            key: e.target.getAttribute('data-key'),
            value: e.target.getAttribute('data-value')
          },
          originalColor: e.target.getAttribute('fill'),
          pos: {
            x: e.target.getAttribute('cx'),
            y: e.target.getAttribute('cy')
          }
        }
      });
      e.target.setAttribute('fill', '#6f8679');
    };

    _this.hideToolTip = function (e) {
      e.target.setAttribute('fill', _this.state.tooltip.originalColor);
      _this.setState({
        tooltip: {
          display: false,
          data: {
            key: '',
            value: ''
          },
          originalColor: '',
          pos: {
            x: 0,
            y: 0
          }
        }
      });
    };

    _this.showToolTip = _this.showToolTip.bind(_this);
    _this.hideToolTip = _this.hideToolTip.bind(_this);
    _this.updateSize = _this.updateSize.bind(_this);
    _this.state = {
      tooltip: {
        display: false,
        data: {
          key: '',
          value: ''
        },
        originalColor: '',
        pos: {
          x: 0,
          y: 0
        }
      },
      width: _this.props.width,
      data: []
    };
    return _this;
  }

  _createClass(ScatterPlot, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      window.addEventListener('resize', this.updateSize, false);
      this.setState({ width: this.props.width });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.reloadBarData();
      this.repaintComponent();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.updateSize, false);
    }
  }, {
    key: 'repaintComponent',
    value: function repaintComponent() {
      var forceResize = this.updateSize;
      function onRepaint(callback) {
        setTimeout(function () {
          window.requestAnimationFrame(callback);
        }, 0);
      }
      onRepaint(forceResize);
    }
  }, {
    key: 'createChart',
    value: function createChart(_self) {
      if (this.props.colors) {
        this.color = _d2.default.scale.ordinal().range(this.props.colors);
      } else {
        this.color = _d2.default.scale.category10();
      }

      var xLabelHeightOffset = 0;
      var yLabelWidthOffset = 0;

      {
        this.props.xAxisLabel ? xLabelHeightOffset = 30 : null;
      }
      {
        this.props.yAxisLabel ? yLabelWidthOffset = 20 : null;
      }

      // Width of graph
      this.w = this.state.width - (this.props.margin.left + this.props.margin.right + yLabelWidthOffset);

      // Height of graph
      this.h = this.props.height - (this.props.margin.top + this.props.margin.bottom + xLabelHeightOffset);

      // X axis scale
      if (this.props.dataType !== 'date') {
        this.xScale = _d2.default.scale.linear().domain([_d2.default.min(this.state.data, function (d) {
          return d[_self.props.xDataKey];
        }), _d2.default.max(this.state.data, function (d) {
          return d[_self.props.xDataKey];
        })]).range([0, this.w]);

        if (this.props.dataPercent === 'x') {
          this.xAxis = _d2.default.svg.axis().scale(this.xScale).orient('bottom').tickFormat(function (x) {
            return x + '%';
          });
        } else {
          this.xAxis = _d2.default.svg.axis().scale(this.xScale).orient('bottom').ticks(Math.floor(this.w / 100));
        }
      } else {
        this.xScale = _d2.default.time.scale().domain(
        // Find min and max axis value
        _d2.default.extent(this.state.data, function (d) {
          return d[_self.props.xDataKey];
        }))
        // Set range from 0 to width of container
        .rangeRound([0, this.w]);

        this.xAxis = _d2.default.svg.axis().scale(this.xScale).orient('bottom').ticks(Math.floor(this.w / 100)).tickFormat(_d2.default.time.format(this.props.xFormat));
      }

      // Y axis scale
      this.yScale = _d2.default.scale.linear().domain([
      // Find min axis value and subtract buffer
      _d2.default.min(this.state.data, function (d) {
        if (typeof _self.props.yMin === "number") {
          return _self.props.yMin;
        } else {
          return d[_self.props.yDataKey] - _self.props.yMaxBuffer;
        }
      }),
      // Find max axis value and add buffer
      _d2.default.max(this.state.data, function (d) {
        if (typeof _self.props.yMax === "number") {
          return _self.props.yMax;
        } else {
          return d[_self.props.yDataKey] + _self.props.yMaxBuffer;
        }
      })])
      // Set range from height of container to 0
      .range([this.h, 0]);

      this.dataNest = _d2.default.nest().key(function (d) {
        return d[_self.props.labelKey];
      }).entries(this.state.data);

      if (this.props.dataPercent === 'y') {
        this.yAxis = _d2.default.svg.axis().scale(this.yScale).orient('left').ticks(5).tickFormat(function (x) {
          return x + '%';
        });
      } else {
        this.yAxis = _d2.default.svg.axis().scale(this.yScale).orient('left').ticks(5);
      }

      this.yGrid = _d2.default.svg.axis().scale(this.yScale).orient('left').ticks(5).tickSize(-this.w, 0, 0).tickFormat("");

      this.transform = 'translate(' + (this.props.margin.left + yLabelWidthOffset) + ',' + this.props.margin.top + ')';
    }
  }, {
    key: 'reloadBarData',
    value: function reloadBarData() {
      var _this2 = this;

      var data = this.props.data;

      // Format date for d3 to use
      var parseDate = _d2.default.time.format(this.props.dateFormat).parse;

      data.forEach(function (value, i) {
        var d = data[i];
        if (_this2.props.dataType === 'date') {
          if (typeof d[_this2.props.xDataKey] === "string") {
            d[_this2.props.xDataKey] = parseDate(d[_this2.props.xDataKey]);
          }
          data[i] = d;
        }
      });

      this.setState({ data: data });
    }
  }, {
    key: 'render',
    value: function render() {
      this.createChart(this);

      var _self = this;

      var dataPoints = this.dataNest.map(function (d, i) {
        var trendLine = [];

        if (_self.props.trendLine) {
          trendLine.push(_react2.default.createElement(_trendLine2.default, {
            key: i,
            data: d.values,
            width: _self.state.width,
            x: _self.xScale,
            y: _self.yScale,
            lineStroke: _self.color(i),
            lineExtend: _self.state.data,
            lineNumbers: _self.props.lineNumbers,
            xDataKey: _self.props.xDataKey,
            yDataKey: _self.props.yDataKey }));
        }

        return _react2.default.createElement(
          'g',
          { key: i },
          trendLine,
          _react2.default.createElement(_dataPoints2.default, {
            data: d.values,
            x: _self.xScale,
            y: _self.yScale,
            fill: _self.color(i),
            showToolTip: _self.showToolTip,
            hideToolTip: _self.hideToolTip,
            dateFormat: _self.props.dataPointDateFormat,
            xDataKey: _self.props.xDataKey,
            yDataKey: _self.props.yDataKey }),
          _react2.default.createElement(_tooltip2.default, {
            tooltip: _self.state.tooltip,
            bgStyle: _self.props.tooltipBgStyle,
            xValue: _self.props.xToolTipLabel,
            yValue: _self.props.yToolTipLabel })
        );
      });

      var customClassName = "";

      if (this.props.chartClassName) {
        customClassName = " " + this.props.chartClassName;
      }

      return _react2.default.createElement(
        'div',
        null,
        this.props.title && _react2.default.createElement(
          'h3',
          null,
          this.props.title
        ),
        _react2.default.createElement(
          'svg',
          { className: "rd3r-chart rd3r-scatter-plot" + customClassName, id: this.props.chartId, width: this.state.width, height: this.props.height },
          _react2.default.createElement(
            'g',
            { transform: this.transform },
            _react2.default.createElement(_grid2.default, { h: this.h, grid: this.yGrid, gridType: 'y' }),
            _react2.default.createElement(_axis2.default, { h: this.h, axis: this.yAxis, axisType: 'y' }),
            _react2.default.createElement(_axis2.default, { h: this.h, axis: this.xAxis, axisType: 'x' }),
            this.props.xAxisLabel && _react2.default.createElement(_axisLabel2.default, { key: 0, h: this.h, w: this.w, axisLabel: this.props.xAxisLabel, axisType: 'x' }),
            this.props.yAxisLabel && _react2.default.createElement(_axisLabel2.default, { key: 1, h: this.h, w: this.w, axisLabel: this.props.yAxisLabel, axisType: 'y' }),
            dataPoints
          )
        ),
        this.props.legend && _react2.default.createElement(_legend2.default, { data: this.state.data, labelKey: this.props.labelKey, colors: this.color })
      );
    }
  }]);

  return ScatterPlot;
}(_react2.default.Component);

ScatterPlot.propTypes = {
  title: _react2.default.PropTypes.string,
  width: _react2.default.PropTypes.number,
  height: _react2.default.PropTypes.number,
  chartId: _react2.default.PropTypes.string,
  chartClassName: _react2.default.PropTypes.string,
  colors: _react2.default.PropTypes.array,
  data: _react2.default.PropTypes.array.isRequired,
  labelKey: _react2.default.PropTypes.string,
  dateFormat: _react2.default.PropTypes.string,
  dataPointDateFormat: _react2.default.PropTypes.string,
  dataType: _react2.default.PropTypes.string,
  dataPercent: _react2.default.PropTypes.string,
  xDataKey: _react2.default.PropTypes.string.isRequired,
  yDataKey: _react2.default.PropTypes.string.isRequired,
  xFormat: _react2.default.PropTypes.string,
  xAxisLabel: _react2.default.PropTypes.string,
  yAxisLabel: _react2.default.PropTypes.string,
  xToolTipLabel: _react2.default.PropTypes.string,
  yToolTipLabel: _react2.default.PropTypes.string,
  tooltipBgStyle: _react2.default.PropTypes.string,
  legend: _react2.default.PropTypes.bool,
  trendLine: _react2.default.PropTypes.bool,
  lineNumbers: _react2.default.PropTypes.oneOf(['single', 'multi']),
  margin: _react2.default.PropTypes.object,
  yMax: _react2.default.PropTypes.number,
  yMin: _react2.default.PropTypes.number,
  yMaxBuffer: _react2.default.PropTypes.number
};

ScatterPlot.defaultProps = {
  width: 1920,
  height: 400,
  labelKey: "label",
  dateFormat: '%m-%d-%Y',
  dataType: 'date',
  xFormat: '%a %e',
  xToolTipLabel: 'x',
  yToolTipLabel: 'y',
  legend: true,
  trendLine: false,
  margin: {
    top: 10,
    right: 40,
    bottom: 30,
    left: 40
  },
  yMaxBuffer: 100
};

exports.default = ScatterPlot;