'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AxisLabel = function AxisLabel(_ref) {
  var w = _ref.w,
      h = _ref.h,
      axisLabel = _ref.axisLabel,
      axisType = _ref.axisType,
      padding = _ref.padding;

  var translateLabelX = "translate(" + w / 2 + "," + (h + 40) + ")";
  var translateLabelY = "translate(" + (-40 - padding) + "," + h / 2 + ") rotate(270)";

  return _react2.default.createElement(
    'text',
    { className: axisType + "-axis-label", textAnchor: 'middle', transform: axisType === 'y' ? translateLabelY : translateLabelX },
    axisLabel
  );
};

AxisLabel.propTypes = {
  w: _react2.default.PropTypes.number,
  h: _react2.default.PropTypes.number,
  padding: _react2.default.PropTypes.number,
  axisLabel: _react2.default.PropTypes.string,
  axisType: _react2.default.PropTypes.oneOf(['x', 'y'])
};

AxisLabel.defaultProps = {
  padding: 0
};

exports.default = AxisLabel;