'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ChartLegend = function ChartLegend(_ref) {
  var data = _ref.data,
      labelKey = _ref.labelKey,
      colors = _ref.colors;

  var legendItems = [];
  var legend = [];

  data.forEach(function (d, i) {
    if (legend.indexOf(d[labelKey]) < 0) {
      legendItems.push(_react2.default.createElement(
        'span',
        { key: i, style: { display: "inline-block" } },
        _react2.default.createElement(
          'span',
          { style: { color: colors(legend.length), paddingRight: '5px' } },
          '\u25CF'
        ),
        _react2.default.createElement(
          'span',
          { style: { paddingRight: '15px' } },
          d[labelKey]
        )
      ));
      legend.push(d[labelKey]);
    }
  });

  return _react2.default.createElement(
    'div',
    { className: 'chart-legend' },
    legendItems
  );
};

ChartLegend.propTypes = {
  data: _react2.default.PropTypes.array,
  labelKey: _react2.default.PropTypes.string,
  colors: _react2.default.PropTypes.func
};

ChartLegend.defaultProps = {
  labelKey: "label"
};

exports.default = ChartLegend;